;; 
;; $Id: slb.s pdonze Exp $
;; 
;; TOS.LIB - (c) 1998 - 2006 Philipp Donze
;; 
;; A replacement for PureC PCTOSLIB.LIB
;; 
;; This file is part of TOS.LIB and contains GEMDOS calls for shared libraries
;; 
;; TOS.LIB is free software; you can redistribute it and/or
;; modify it under the terms of the GNU Library General Public License as
;; published by the Free Software Foundation; either version 2 of the
;; License, or (at your option) any later version.
;;
;; TOS.LIB is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;; Library General Public License for more details.
;;
;; You should have received a copy of the GNU Library General Public
;; License along with the GNU C Library; see the file COPYING.LIB.  If not,
;; write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.
;; 

; All bindings use Pure C's parameter passing convention:
;   The first three (3) scalar arguments ( char, int, long) use D0-D2.
;   The first two (2) address parameters (pointers) use A0-A1.
;   The first three (3) floatingpoint args use FP0-FP2. (NOT USED HERE)
;
;   Scalar return values ( char, int, long) are expected in D0
;   Address return values (pointer) are expected in A0
;   Floating point return values are expected in FP0. (NOT USED HERE)
;
; => Registers D0-D2/A0-A1/FP0-FP2 are free for use in assembly code.
; Other registers have to be saved and restored.

; GEMDOS saves and restores automatically D3-D7 and A3-A7, other
; registers can be destroyed by a trap.
; Return value (data or address) is always in D0.

; --------------------------------------------------------------------
; tabsize = 4
; 	<asm>	<params>		; <comment>


_STC	EQU		4				; stack offset caused by macro REGSave

MACRO REGSave					; macro for saving registers before trap
		pea		(A2)
ENDM

MACRO REGLoad					; macro for restoring registers after trap
		movea.l	(SP)+,A2
ENDM






; --------------------------------------------------------------------
; extensions for shared libraries
; --------------------------------------------------------------------

export Slbopen
MODULE Slbopen
; long	Slbopen( char *name, char *path, long min_ver, SLB_HANDLE *sl, SLB_EXEC *fn );
		REGSave
		move.l	_STC+$8(sp),-(sp)
		move.l	_STC+$8(sp),-(sp)
		move.l	D0,-(sp)
		pea		(a1)
		pea		(a0)
		move.w	#22,-(sp)
		trap	#1				; Gemdos(22)
		adda.l	#22,sp
		REGLoad
		rts
ENDMOD

export Slbclose
MODULE Slbclose
; long	Slbclose( SLB_HANDLE *sl );
		REGSave
		pea		(a0)
		move.w	#23,-(sp)
		trap	#1				; Gemdos(23)
		addq.l	#6,sp
		REGLoad
		rts
ENDMOD
